"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var program = require("commander");
var config_1 = require("./config");
var add_1 = require("./add");
var remove_1 = require("./remove");
var upload_1 = require("./upload");
var download_1 = require("./download");
var version_1 = require("../version");
// Version
program.version(version_1.default);
// Commands
program.command('config <type> [key] [value]').action(config_1.default);
program.command('add <file> [path]').action(function (file, path) { return add_1.default(file, path); });
program.command('remove <file>').action(function (file) { return remove_1.default(file); });
program.command('upload').action(function () {
    upload_1.default();
});
program.command('download').action(function () {
    download_1.default();
});
// Parse and execute
program.parse(process.argv);
//# sourceMappingURL=cli.js.map