"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
var print_1 = require("./print");
var config = require("../config");
exports.default = (function (type, key, value) {
    switch (type) {
        case 'get':
            if (lodash_1.isNil(key)) {
                print_1.default.config(config.getConfig());
            }
            else if (config.keys.validate(key)) {
                print_1.default.config(config.getConfig(), key);
            }
            else {
                print_1.default.error('Input error', "Invalid key '" + key + "'");
            }
            break;
        case 'set':
            if (config.keys.validate(key, value)) {
                var newConfig = config.setConfig(key, value);
                print_1.default.config(newConfig, key);
            }
            else {
                print_1.default.error('Input error', "Invalid key '" + key + "' and value '" + value + "'");
            }
            break;
        default:
            print_1.default.error('Input type', "Invalid type '" + type + "'. Only 'set' and 'get' is available");
    }
});
//# sourceMappingURL=config.js.map