"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var leftPad = require("left-pad");
var co_1 = require("co");
var co_prompt_1 = require("co-prompt");
var chalk_1 = require("chalk");
var gist_1 = require("../github/gist");
var download_1 = require("../download");
var config_1 = require("../config");
var print_1 = require("./print");
var executeDownload = function () { return __awaiter(_this, void 0, void 0, function () {
    var downloadedFiles;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, download_1.download()];
            case 1:
                downloadedFiles = _a.sent();
                print_1.default.info("Downloaded files successfully.");
                print_1.default.info(downloadedFiles
                    .map(function (_a) {
                    var name = _a.name, path = _a.path;
                    return leftPad(name, 15) + " > " + path;
                })
                    .join('\n'));
                return [2 /*return*/];
        }
    });
}); };
exports.default = (function () {
    var gist = String(config_1.getConfig('repository.gist'));
    var getGistAndDownload = gist && gist.length
        ? gist_1.get(gist).then(executeDownload)
        : Promise.reject({ code: 404 });
    getGistAndDownload.catch(function (e) {
        // Gist id is not set or invalid gist id
        if (e && e.code === 404) {
            co_1.default(function () {
                var gistId;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            print_1.default.error('Invalid gist', 'Gist id is not set or invalid.');
                            return [4 /*yield*/, co_prompt_1.default(chalk_1.default.green('Gist id: '))];
                        case 1:
                            gistId = _a.sent();
                            gist_1.get(gistId)
                                .then(function (_a) {
                                var id = _a.data.id;
                                return config_1.setConfig('repository.gist', id);
                            })
                                .then(executeDownload)
                                .catch(function (_a) {
                                var message = _a.message, others = __rest(_a, ["message"]);
                                return print_1.default.error("GIST ERROR", message + ' ' + JSON.stringify(others));
                            })
                                .then(function () { return process.stdin.pause(); });
                            return [2 /*return*/];
                    }
                });
            });
        }
    });
});
//# sourceMappingURL=download.js.map