"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = require("chalk");
var lodash_1 = require("lodash");
function info() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    console.log.apply(console, args);
}
function printConfigPair(config, key) {
    info(key + " = " + lodash_1.get(config, key));
}
function printConfigObject(config) {
    Object.keys(config).forEach(function (k) { return printConfigPair(config, k); });
}
var print = {
    config: function (config, key) {
        return lodash_1.isNil(key) ? printConfigObject(config) : printConfigPair(config, key);
    },
    info: info,
    warn: function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return console.log.apply(console, args.map(function (a) { return chalk_1.default.bold.yellow(a); }));
    },
    error: function (type, message) {
        return console.error(chalk_1.default.red("ERROR: " + (type || '') + " - " + (message || '')));
    },
};
exports.default = print;
//# sourceMappingURL=print.js.map