"use strict";
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var co_1 = require("co");
var co_prompt_1 = require("co-prompt");
var chalk_1 = require("chalk");
var config_1 = require("../config");
var upload_1 = require("../upload");
var print_1 = require("./print");
var gist_1 = require("../github/gist");
var executeUpload = function () {
    return upload_1.upload()
        .catch(function (err) {
        return new Promise(function (resolve, reject) {
            if (err && err.code === 401) {
                co_1.default(function () {
                    var githubToken;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                print_1.default.error('Invalid token', 'Github Token is not valid.');
                                return [4 /*yield*/, co_prompt_1.default(chalk_1.default.green('Github Token: '))];
                            case 1:
                                githubToken = _a.sent();
                                config_1.setConfig('repository.githubToken', githubToken);
                                resolve(upload_1.upload());
                                return [2 /*return*/];
                        }
                    });
                });
            }
            else {
                reject(err);
            }
        });
    })
        .then(function (_a) {
        var uploaded = _a.uploaded, deleted = _a.deleted;
        print_1.default.info("Success");
        if (uploaded.length) {
            print_1.default.info(chalk_1.default.bold.blue('Uploaded files'));
            print_1.default.info(uploaded.map(function (f) { return "  - " + f; }).join('\n'));
        }
        if (deleted.length) {
            print_1.default.info(chalk_1.default.bold.magenta('Deleted files'));
            print_1.default.info(deleted.map(function (f) { return "  - " + f; }).join('\n'));
        }
    });
};
exports.default = (function () {
    var gist = config_1.getConfig('repository.gist');
    var getGistAndUpload = gist && gist.length
        ? gist_1.get(gist).then(function (r) {
            return r && r.data && r.data.files
                ? executeUpload()
                : Promise.reject({ code: 404 });
        })
        : Promise.reject({ code: 404 });
    getGistAndUpload.catch(function (e) {
        // Gist id is not set or invalid gist id
        if (e && e.code === 404) {
            co_1.default(function () {
                var gistId, createOrGet, response, publicity;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            print_1.default.error('Invalid gist', 'Gist id is not set or invalid.');
                            return [4 /*yield*/, co_prompt_1.default(chalk_1.default.green('Gist id(Empty to create a new gist): '))];
                        case 1:
                            gistId = _a.sent();
                            if (!(gistId && gistId.length)) return [3 /*break*/, 2];
                            createOrGet = gist_1.get(gistId).then(function () {
                                return config_1.setConfig('repository.gist', gistId);
                            });
                            return [3 /*break*/, 4];
                        case 2: return [4 /*yield*/, co_prompt_1.default(chalk_1.default.green('Do you want to make it public?(y/n)'))];
                        case 3:
                            response = _a.sent();
                            publicity = ['y', 'yes'].indexOf(response.toLowerCase()) !== -1;
                            print_1.default.info("Gist will be created in " + chalk_1.default.bold.white(publicity ? 'pubic' : 'private') + ".");
                            createOrGet = gist_1.create({
                                files: upload_1.getUploadingFiles(),
                                public: publicity,
                            });
                            _a.label = 4;
                        case 4:
                            createOrGet
                                .then(function () { return config_1.setConfig('repository.gist', gistId); })
                                .then(executeUpload)
                                .catch(function (_a) {
                                var message = _a.message;
                                return print_1.default.error("GIST ERROR", message);
                            })
                                .then(function () { return process.stdin.pause(); });
                            return [2 /*return*/];
                    }
                });
            });
        }
    });
});
//# sourceMappingURL=upload.js.map