"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// @flow
var lodash_1 = require("lodash");
var keyMap = {
    'repository.type': /(gist)/,
    'repository.gist': /[\W]*/,
    'repository.githubToken': /[\w\W]*/,
    'file.createBackup': /(true|false)/,
};
var keys = Object.keys(keyMap);
keys.forEach(function (key) {
    exports[key] = keyMap[key];
});
function validate(key, value) {
    if (key.match(/path\.*/))
        return true;
    if (!lodash_1.has(keyMap, key))
        return false;
    if (arguments.length > 1) {
        if (lodash_1.isNil(value))
            return false;
        return String(value).match(keyMap[key]) !== null;
    }
    return keyMap.hasOwnProperty(key);
}
exports.validate = validate;
//# sourceMappingURL=keys.js.map