"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var github_1 = require("./github");
var config_1 = require("../config");
exports.create = function (option) {
    github_1.authenticate();
    return github_1.default.gists
        .create(__assign({ description: 'Gist for icbm', public: false }, option))
        .then(function (res) { return config_1.setConfig('repository.gist', res.data.id); });
};
exports.get = function (id) {
    id = id || String(config_1.getConfig('repository.gist'));
    if (!id || !id.length)
        return Promise.reject({ message: 'ID is empty' });
    /* eslint-disable-next-line @typescript-eslint/camelcase */
    return github_1.default.gists.get({ gist_id: id });
};
exports.edit = function (files) {
    github_1.authenticate();
    return github_1.default.gists.update({
        /* eslint-disable-next-line @typescript-eslint/camelcase */
        gist_id: String(config_1.getConfig('repository.gist')),
        files: files,
    });
};
//# sourceMappingURL=gist.js.map