"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Octokit = require("@octokit/rest");
var config_1 = require("../config");
var version_1 = require("../version");
var github = new Octokit({
    debug: process.env.NODE_ENV !== 'production',
    headers: {
        'user-agent': "icbm v" + version_1.default + ", node v" + process.versions.node,
    },
});
exports.default = github;
exports.authenticate = function () {
    var token = config_1.getConfig('repository.githubToken');
    if (!token)
        throw new Error("Set github token using 'icbm config set repository.githubToken <token>'");
    var auth = { type: 'oauth', token: String(token) };
    github.authenticate(auth);
    return Promise.resolve();
};
//# sourceMappingURL=github.js.map