"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
var path = require("path");
var mkdirp_1 = require("mkdirp");
var fs_extra_1 = require("fs-extra");
var paths_1 = require("../paths");
var config = require("../config");
var RemoveResponseType;
(function (RemoveResponseType) {
    RemoveResponseType[RemoveResponseType["AlreadyRemoved"] = 0] = "AlreadyRemoved";
    RemoveResponseType[RemoveResponseType["Success"] = 1] = "Success";
    RemoveResponseType[RemoveResponseType["Fail"] = 2] = "Fail";
})(RemoveResponseType = exports.RemoveResponseType || (exports.RemoveResponseType = {}));
exports.default = (function (file) {
    mkdirp_1.sync(paths_1.appDir);
    var configKey = "path." + file;
    var filePath = String(config.getConfig(configKey));
    if (lodash_1.isNil(filePath))
        return RemoveResponseType.AlreadyRemoved;
    fs_extra_1.removeSync(filePath);
    if (fs_extra_1.existsSync(path.join(paths_1.appDir, file))) {
        fs_extra_1.copyFileSync(path.join(paths_1.appDir, file), filePath);
        fs_extra_1.removeSync(path.join(paths_1.appDir, file));
        config.removeConfig(configKey);
        return RemoveResponseType.Success;
    }
    config.removeConfig(configKey);
    return RemoveResponseType.AlreadyRemoved;
});
//# sourceMappingURL=remove.js.map